<template>
  <div style="border: 1px solid lightseagreen; margin-top: 10px">
    <div v-for="row in gridRows" :key="row" style="margin: 5px 5px 5px 5px">
      <div
        style="display: grid"
        :style="{
          gridTemplateColumns: `repeat(${gridColumnNum}, 1fr)`,
          width: size * gridColumnNum + 'px',
        }"
      >
        <div
          :id="getLocationCode(row, col)"
          v-for="col in gridColmuns"
          :key="getLocationCode(row, col)"
          :style="{
            width: size + 'px',
            height: size + 'px',
          }"
        >
          <el-popover placement="bottom" :width="300" trigger="click">
            <template #reference>
              <location-info :location="getLocation(row, col)"></location-info>
            </template>
            <el-row>
              <el-col>
                货位编号：{{
                getLocation(row, col) ? getLocation(row, col).code : ""
                }}
              </el-col>
            </el-row>
            <el-row>
              <el-col>
                托盘条码：{{
                getLocation(row, col) ? getLocation(row, col).barcode : ""
                }}
              </el-col>
            </el-row>
            <el-row>
              <el-col>
                物料编码：{{
                getLocation(row, col) ? getLocation(row, col).materiaCode : ""
                }}
              </el-col>
            </el-row>
            <el-row>
              <el-col>
                物料名称：{{
                getLocation(row, col)
                ? getLocation(row, col).materialName
                : ""
                }}
              </el-col>
            </el-row>
            <el-row>
              <el-col>
                数量：{{
                getLocation(row, col) ? getLocation(row, col).qty : ""
                }}
              </el-col>
            </el-row>
          </el-popover>
        </div>
      </div>

      <el-divider
        v-if="row === tunnelRowNo - 1 && tunnelRowNo !== 0"
        content-position="center"
      >{{ tunnel }}#巷道</el-divider>
    </div>
  </div>
</template>
    
    <script>
import LocationInfo from "./LocationInfo.vue";
export default {
  name: "StockPlan",
  props: {
    gridColumnNum: {
      type: Number,
      default: 1
    },
    gridRowNum: {
      type: Number,
      default: 1
    },
    locationList: {
      type: Array,
      default: () => []
    },
    tunnelRowNo: {
      type: Number,
      default: 0
    },
    tunnel: {
      type: String,
      default: "1"
    },
    layer: {
      type: String,
      default: "1"
    }
  },
  data() {
    return {
      gridColmuns: [],
      gridRows: [],
      size: 60
    };
  },
  components: {
    LocationInfo
  },
  computed: {},
  async created() {
    for (let i = 0; i < this.gridColumnNum; i++) {
      this.gridColmuns.push(i);
    }
    for (let i = 0; i < this.gridRowNum + 1; i++) {
      this.gridRows.push(i);
    }
    this.size = this.itemSize;
  },
  mounted() {},
  methods: {
    // getLocationCode(row, col) {
    //   let location = this.locationList.find(
    //     (item) => item.row === row && item.col === col + 1
    //   );
    //   if (location) {
    //     return true;
    //   }
    //   return false;
    // },
    getLocation(row, col) {
      let location = this.locationList.find(
        item => item.row === row && item.col === col + 1
      );
      // console.log(location);
      return location;
    },
    isExist(row, col) {
      let location = this.getLocation(row, col);
      if (location) {
        return true;
      }
      return false;
    },
    getLocationStateImg(row, col) {
      let location = this.getLocation(row, col);
      if (location) {
        if (location.state === "LocationState_Empty") {
          return "";
        } else if (location.state === "LocationState_Stored") {
          return "../../public/Stored.png";
        }
      }
      return "";
    },
    getLocationCode(row, col) {
      return row + "-" + (col + 1);
    }
  }
};
</script>
    
    <style scoped>
</style>